From: Jakub Jelen <jjelen@redhat.com>
Date: Mon, 7 Dec 2020 12:14:31 +0100
Subject: gpk: Replace assert with error

Thanks oss-fuzz

Origin: https://github.com/OpenSC/OpenSC/commit/196bf9e574fb421b5d0f7f5f064d86631df259ad
Bug: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=28306
---
 src/libopensc/card-gpk.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/src/libopensc/card-gpk.c b/src/libopensc/card-gpk.c
index 2bfcdde..666e9fa 100644
--- a/src/libopensc/card-gpk.c
+++ b/src/libopensc/card-gpk.c
@@ -552,7 +552,9 @@ gpk_select_id(sc_card_t *card, int kind, unsigned int fid,
 			cp->len = 0;
 			/* fallthru */
 		case GPK_SEL_DF:
-			assert(cp->len + 1 <= SC_MAX_PATH_SIZE / 2);
+			if (cp->len + 1 > SC_MAX_PATH_SIZE / 2) {
+				return SC_ERROR_INTERNAL;
+			}
 			path = (unsigned short int *) cp->value;
 			path[cp->len++] = fid;
 		}
